format pe64 dll efi at 0
entry main

 
section '.text' code executable readable
 
include 'uefi.inc'

;EFI_WAIT_TIME = 0x00000001
MEMORY_MAP_SIZE = 0x4000
 
CODE_32_SELECTOR = 8
DATA_32_SELECTOR = 16
CODE_64_SELECTOR = 24

E820_RAM       = 1
E820_RESERVED  = 2
E820_ACPI      = 3
E820_NVS       = 4
E820_UNUSABLE  = 5
E820_PMEM      = 7
E820_MAX       = 128

main:
        sub     rsp, 0x38
        ; initialize UEFI library
        InitializeLib
        jc      .error
 
;        uefi_call_wrapper ConOut, Reset, ConOut, 1
;        cmp     rax, EFI_SUCCESS
;        jnz     .error

        uefi_call_wrapper ConOut, ClearScreen, ConOut
        cmp     rax, EFI_SUCCESS
        jnz     .error

        uefi_call_wrapper ConOut, OutputString, ConOut, msg_hello
        cmp     eax, EFI_SUCCESS
        jnz     .error
;mov ecx, -1
;@@:
;dec ecx
;jnz @b
        uefi_call_wrapper BootServices, LocateHandle, 2, gopuuid, 0, gop_buffer_size, gop_buffer
        cmp     eax, EFI_SUCCESS
        jnz     .error

        mov     rsi, gop_buffer
        lodsq
        mov     [gop_handle], rax
        uefi_call_wrapper BootServices, HandleProtocol, qword [gop_handle], gopuuid, gop_interface
        cmp     eax, EFI_SUCCESS
        jnz     .error


        xor     ebx, ebx
  .next_mode:
        call    clearbuf
        mov     eax, ebx
        lea     rdi, [msg_mode]
        call    num2dec

        push    rbx
        uefi_call_wrapper [gop_interface], EFI_GRAPHICS_OUTPUT_PROTOCOL.QueryMode, [gop_interface], rbx, gop_info_size, gop_info
        cmp     rax, EFI_SUCCESS
        jnz     .error
        mov     rcx, [gop_info]
        cmp     [rcx + EFI_GRAPHICS_OUTPUT_MODE_INFORMATION.PixelFormat], 1     ; PixelBlueGreenRedReserved8BitPerColor
        jnz     .skip
        mov     eax, [rcx + EFI_GRAPHICS_OUTPUT_MODE_INFORMATION.HorizontalResolution]
        lea     rdi, [msg_mode+4*2]
        call    num2dec
        mov     eax, [rcx + EFI_GRAPHICS_OUTPUT_MODE_INFORMATION.VerticalResolution]
        lea     rdi, [msg_mode+9*2]
        call    num2dec
;        mov     eax, [rcx + EFI_GRAPHICS_OUTPUT_MODE_INFORMATION.PixelsPerScanLine]
;        lea     rdi, [msg_mode+14*2]
;        call    num2dec
  .skip:
        uefi_call_wrapper ConOut, OutputString, ConOut, msg_mode
        cmp     rax, EFI_SUCCESS
        jnz     .error

        pop     rbx
        inc     rbx
        mov     rcx, [gop_interface]
        mov     rdx, [rcx + EFI_GRAPHICS_OUTPUT_PROTOCOL.Mode]
        cmp     ebx, [rdx + EFI_GRAPHICS_OUTPUT_PROTOCOL_MODE.MaxMode]
        jnz     .next_mode


;        uefi_call_wrapper ConIn, Reset, ConIn, 1
;        cmp     rax, EFI_SUCCESS
;        jnz     .error
        xor     ecx, ecx
    @@:
        push    rcx
        uefi_call_wrapper ConIn, ReadKeyStroke, ConIn, msg_mode
        pop     rcx
        mov     rdx, EFI_DEVICE_ERROR
        cmp     rax, rdx
        jz      .error
        mov     rdx, EFI_NOT_READY
        cmp     rax, rdx
        jz      @b
;        cmp     rax, EFI_SUCCESS
        movzx   eax, word[msg_mode+2]
;jmp .key_done
        cmp     al, 0x0D
        jz      .key_done
        imul    ecx, 10
        sub     eax, '0'
        add     ecx, eax
        jmp     @b
  .key_done:
;        call    clearbuf
;        mov     eax, ecx
;        lea     rdi, [msg_mode]
;        call    num2dec
;        uefi_call_wrapper ConOut, OutputString, ConOut, msg_mode
;        cmp     rax, EFI_SUCCESS
;        jnz     .error

        uefi_call_wrapper [gop_interface], EFI_GRAPHICS_OUTPUT_PROTOCOL.SetMode, [gop_interface], rcx
        cmp     eax, EFI_SUCCESS
        jnz     .error

        mov     rcx, [gop_interface]
        mov     rdx, [rcx + EFI_GRAPHICS_OUTPUT_PROTOCOL.Mode]
        mov     rdi, [rdx + EFI_GRAPHICS_OUTPUT_PROTOCOL_MODE.FrameBufferBase]
        mov     [fb_base], rdi

;push rax rbx rcx rdx rsi rdi
;mov rdi,[fb_base]
;mov eax, 0xffff0000
;mov ecx, 1024*768
;rep stosd
;mov ecx, EFI_WAIT_TIME
;loop $
;pop  rdi rsi rdx rcx rbx rax
;push rax rbx rcx rdx rsi rdi
;mov rdi,[fb_base]
;mov eax, 0xff00ff00
;mov ecx, 1024*768
;rep stosd
;mov ecx, EFI_WAIT_TIME
;loop $
;pop  rdi rsi rdx rcx rbx rax

        mov     ebx, [rdx + EFI_GRAPHICS_OUTPUT_PROTOCOL_MODE.CurrentMode]
        uefi_call_wrapper [gop_interface], EFI_GRAPHICS_OUTPUT_PROTOCOL.QueryMode, [gop_interface], rbx, gop_info_size, gop_info
        cmp     rax, EFI_SUCCESS
        jnz     .error
        mov     rcx, [gop_info]
        mov     rdx, 0x9000
        mov     eax, [rcx + EFI_GRAPHICS_OUTPUT_MODE_INFORMATION.HorizontalResolution]
        mov     word[rdx+0x0A], ax
        mov     eax, [rcx + EFI_GRAPHICS_OUTPUT_MODE_INFORMATION.VerticalResolution]
        mov     word[rdx+0x0C], ax
        mov     eax, [rcx + EFI_GRAPHICS_OUTPUT_MODE_INFORMATION.PixelsPerScanLine]
        shl     eax, 2
        mov     word[rdx+0x01], ax


        uefi_call_wrapper BootServices, GetMemoryMap, memory_map_size, memory_map, memory_map_key, descriptor_size, descriptor_ver
        cmp     eax, EFI_SUCCESS
        jnz     .error

;        call    clearbuf
;        mov     rax, [fb_base]
;        lea     rdi, [msg_mode]
;        call    num2hex
;        uefi_call_wrapper ConOut, OutputString, ConOut, msg_mode
;        cmp     rax, EFI_SUCCESS
;        jnz     .error

;        mov     ecx, 0xd0000000
;        loop    $

;push rax rbx rcx rdx rsi rdi
;mov rdi,[fb_base]
;mov eax, 0xff0000ff
;mov ecx, 1024*768
;rep stosd
;mov ecx, EFI_WAIT_TIME
;loop $
;pop  rdi rsi rdx rcx rbx rax
        mov     rdi, 0x9100
        mov     dword[rdi], 0
        add     rdi, 4
        mov     rax, [memory_map_size]
        xor     edx, edx
        mov     rcx, [descriptor_size]
        div     ecx
        mov     ecx, eax
        mov     rsi, memory_map
  .next_descr:
;        push    rcx rsi rdi
;        call    clearbuf
;        mov     eax, [rsi + 0]
;        lea     rdi, [msg_mode]
;        call    num2dec
;        mov     rax, [rsi + 8]
;        mov     rbx, [rsi + 8]
;        lea     rdi, [msg_mode + (2+1)*2]
;        call    num2hex
;        mov     rax, [rsi + 8+8+8]
;        lea     rdi, [msg_mode + (2+1+16+1)*2]
;        shl     rax, 12
;        dec     rax
;        add     rax, rbx
;        call    num2hex
;        uefi_call_wrapper ConOut, OutputString, ConOut, msg_mode
;        cmp     rax, EFI_SUCCESS
;        jnz     .error
;        pop     rdi rsi rcx
        call    add_efi_memmap
        add     rsi, [descriptor_size]
        add     rdi, 20
        dec     rcx
        cmp     rcx, 0
        jnz     .next_descr

;push rax rbx rcx rdx rsi rdi
;mov rdi,[fb_base]
;mov eax, 0xffffff00
;mov ecx, 1024*768
;rep stosd
;mov ecx, EFI_WAIT_TIME
;loop $
;pop  rdi rsi rdx rcx rbx rax

        mov     [memory_map_size], MEMORY_MAP_SIZE
        uefi_call_wrapper BootServices, GetMemoryMap, memory_map_size, memory_map, memory_map_key, descriptor_size, descriptor_ver
        cmp     eax, EFI_SUCCESS
        jnz     .error

        uefi_call_wrapper BootServices, ExitBootServices, [efi_handler], [memory_map_key]
        cmp     eax, EFI_SUCCESS
        jnz     .error


        cli
        cld
        mov     al, 255         ; mask all irqs
        out     0xa1, al
        out     0x21, al

;        mov     ax, DATA_32_SELECTOR
;        mov     ds, ax
;        mov     es, ax
;        mov     fs, ax
;        mov     gs, ax
;        mov     ss, ax

        mov     rsi, kernel_mnt_data_begin
        mov     rdi, 0x10000
        mov     rcx, kernel_mnt_data_end-kernel_mnt_data_begin
        rep     movsb

        mov     rsi, kolibri_img_data_begin
        mov     rdi, 0x100000
        mov     rcx, kolibri_img_data_end-kolibri_img_data_begin
        rep     movsb

        mov     esi, 0x9000
        mov     byte[esi + 0x00], 32
;        mov     word[esi + 0x01], 1024*4
        mov     word[esi + 0x08], 0
;        mov     word[esi + 0x0A], 1024
;        mov     word[esi + 0x0C], 768
        mov     dword[esi + 0x14], 0
        mov     rdi, [fb_base]
        mov     dword[esi + 0x18], edi
        mov     byte[esi + 0x1C], 1
        mov     byte[esi + 0x1D], 1
        mov     byte[esi + 0x1E], 0     ; duplicate debug output to the screen
        mov     byte[esi + 0x1F], 0
        mov     qword[esi + 0x20], 0
        mov     byte[esi + 0x30], 2
        mov     dword[esi + 0x40], 0
        mov     word[esi + 0x44], 0
        mov     dword[esi + 0x46], 0
        mov     word[esi + 0x50], 0
        mov     word[esi + 0x52], 0
        mov     word[esi + 0x54], 0
        mov     byte[esi + 0x7F], 0
        
;push rax rbx rcx rdx rsi rdi
;mov rdi,[fb_base]
;mov eax, 0xff00ffff
;mov ecx, 1024*768
;rep stosd
;mov ecx, EFI_WAIT_TIME
;loop $
;pop  rdi rsi rdx rcx rbx rax


        lgdt    [cs:GDTR]

        mov     ax, DATA_32_SELECTOR
        mov     ds, ax
        mov     es, ax
        mov     fs, ax
        mov     gs, ax
        mov     ss, ax

;push rax rbx rcx rdx rsi rdi
;mov rdi,[fb_base]
;mov eax, 0xff00ff00
;mov ecx, 1024*768
;rep stosd
;mov ecx, EFI_WAIT_TIME
;loop $
;pop  rdi rsi rdx rcx rbx rax
        push    CODE_32_SELECTOR
        lea     rax, [.next]
        push    rax
;        push    .next
        retf
use32
align 16
  .next:
        mov     esp, stack_top
;push eax ebx ecx edx esi edi
;mov edi,dword[fb_base]
;mov eax, 0xffffffff
;mov ecx, 1024*768
;rep stosd
;mov ecx, EFI_WAIT_TIME
;loop $
;pop  edi esi edx ecx ebx eax
        mov     eax, cr0
        btr     eax, 31
        mov     cr0, eax

        mov     ecx, 0xC0000080
        rdmsr
        btr     eax, 8
        wrmsr
        
        mov     eax, cr4
        btr     eax, 5
        mov     cr4, eax
;        mov     eax, 0x90
;        mov     cr4, eax

;push eax ebx ecx edx esi edi
;mov edi,dword[fb_base]
;mov eax, 0xffff00ff
;mov ecx, 1024*768
;rep stosd
;mov ecx, EFI_WAIT_TIME
;loop $
;pop  edi esi edx ecx ebx eax

;        push    $
;        push    CODE_32_SELECTOR
;        push    0x11930
;        retf
        push    0x11930
        ret

use64
  .device_error:
        uefi_call_wrapper ConOut, OutputString, ConOut, msg_device_error
        jmp     .quit
  .invalid_param_error:
        uefi_call_wrapper ConOut, OutputString, ConOut, msg_invalid_param_error
        jmp     .quit
  .error:
        uefi_call_wrapper ConOut, OutputString, ConOut, msg_error
        jmp     .quit
  .quit:
        mov     rcx, -1
        loop    $


add_efi_memmap:
        push    rax rbx rcx rdx rsi rdi

        mov     r10d, [rsi + 0]
        mov     r11, [rsi + 8]
        mov     r12, [rsi + 16]
        mov     r13, [rsi + 24]
        mov     r14, [rsi + 32]

        mov     [rdi + 0], r11
        mov     rax, r13
        shl     rax, 12
        mov     [rdi + 8], rax


        cmp     r10d, EFI_LOADER_CODE
        jz      .case0
        cmp     r10d, EFI_LOADER_DATA
        jz      .case0
        cmp     r10d, EFI_BOOT_SERVICES_CODE
        jz      .case0
        cmp     r10d, EFI_BOOT_SERVICES_DATA
        jz      .case0
        cmp     r10d, EFI_CONVENTIONAL_MEMORY
        jz      .case0
        cmp     r10d, EFI_ACPI_RECLAIM_MEMORY
        jz      .case1
        cmp     r10d, EFI_ACPI_MEMORY_NVS
        jz      .case2
        cmp     r10d, EFI_UNUSABLE_MEMORY
        jz      .case3
        cmp     r10d, EFI_PERSISTENT_MEMORY
        jz      .case4
        jmp     .default

  .case0:
        test    r14, EFI_MEMORY_WB
        jz      @f
        mov     eax, E820_RAM
        jmp     .done
    @@:
        mov     eax, E820_RESERVED
        jmp     .done
  .case1:
        mov     eax, E820_ACPI
        jmp     .done
  .case2:
        mov     eax, E820_NVS
        jmp     .done
  .case3:
        mov     eax, E820_UNUSABLE
        jmp     .done
  .case4:
        mov     eax, E820_PMEM
        jmp     .done
  .default:
        mov     eax, E820_RESERVED
        jmp     .done

  .done:
        mov     [rdi + 16], eax

        mov     rax, 0x9100
        inc     word[rax]

        pop     rdi rsi rdx rcx rbx rax
        ret


num2dec:
        push    rax rbx rcx rdx rsi rdi

        xor     ecx, ecx
        mov     ebx, 10
  .next_digit:
        xor     edx, edx
        div     ebx
        push    rdx
        inc     ecx
        test    eax, eax
        jnz     .next_digit

  .next_char:
        pop     rax
        add     eax, '0'
        stosw
        loop    .next_char

        pop     rdi rsi rdx rcx rbx rax
        ret


num2hex:
        push    rax rbx rcx rdx rsi rdi

        xchg    rdx, rax
        mov     ecx, 16
  .next_tetra:
        rol     rdx, 4
        movzx   eax, dl
        and     eax, 0x0f
        movzx   eax, byte[hex+eax]
        stosw
        loop    .next_tetra

        pop     rdi rsi rdx rcx rbx rax
        ret

hex db '0123456789ABCDEF'

clearbuf:
        push    rax rcx rdi
        mov     eax, 0x0020
        mov     ecx, 40
        mov     rdi, msg_mode
        rep     stosw
        pop     rdi rcx rax
        ret

section '.data' data readable writeable

GDTR:                                   ; Global Descriptors Table Register                                                                                               
  dw 4*8-1                              ; limit of GDT (size minus one)
  dq GDT                                ; linear address of GDT

GDT dw 0, 0, 0, 0                       ; null desciptor
    dw 0FFFFh,0,9A00h,0CFh              ; 32-bit code desciptor
    dw 0FFFFh,0,9200h,0CFh              ; flat data desciptor
    dw 0FFFFh,0,9A00h,0AFh              ; 64-bit code desciptor


fb_base         dq 0

gopuuid         db EFI_GRAPHICS_OUTPUT_PROTOCOL_UUID
gop_buffer_size dq 800
gop_buffer      rb 800
gop_handle      dq 0
gop_interface   dq 0
gop_info_size   dq 0
gop_info        dq 0

memory_map_key  dq 0
descriptor_size dq 0
descriptor_ver  dq 0
memory_map_size dq MEMORY_MAP_SIZE

rb 0x8000
stack_top:

msg_hello       du 'Hello, World!',13,10,0
msg_error       du 'Error!',13,10,0
msg_device_error       du 'Device error!',13,10,0
msg_invalid_param_error       du 'Invalid parameter error!',13,10,0
msg_mode        du 'r                                                                            ',13,10,0
memory_map      rb MEMORY_MAP_SIZE

kolibri_img_data_begin:
file 'kolibri.img'
kolibri_img_data_end:

kernel_mnt_data_begin:
file 'kernel.mnt'
kernel_mnt_data_end:
 
align 16

data fixups
end data
;section '.reloc' fixups data discardable
